/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/


/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 *
 *	$Id: defs.h,v 1.2 2000/12/06 10:36:11 prima Exp $
 */

#include <PICA/pica.h>


#ifdef PICA_LINUX
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <net/route.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <netdb.h>
#endif



#include <signal.h>
//#include <syslog.h>
#include <stdio.h>
#include <stdlib.h>
//#include <search.h>
#include <string.h>
//#include <unistd.h>
#include <errno.h>

#include "types.h"
#include "packet.h"
#include "trace.h"
#include "interface.h"
#include "two_hop_neighbor_table.h"
#include "neighbor_table.h"
#include "mpr_selector_table.h"
#include "duplicate_table.h"
#include "topology_table.h"
#include "routing_table.h"
#include "af.h"
#include "olsr.h"
#include "top_statique.h"
#include "kernel_routes.h"
#include "ins_rem_q.h"

#define equal(a1, a2) \
	(memcmp((a1), (a2), sizeof (struct sockaddr)) == 0)

#ifndef PICA_LINUX
#define RTF_UP			0x0001
#define RTF_GATEWAY		0x0002
#define RTF_HOST		0x0004
#endif

#define UP             1
#define DOWN           0

#define TRUE           1

#define NOT_DETECTED   0

#define OLSRPORT       698
#define OLSRTOOLSPORT  IPPORT_RESERVED - 1

extern struct timeval  hold_time_neighbor ;
extern struct timeval  hold_time_topology;
extern struct timeval  hold_time_duplicate_tc;

//extern sigset_t psigset;  /* set of blocked signals which have been raised while blocked */

extern olsr_8_t changes_topology;
extern olsr_8_t changes_neighborhood;

extern struct neighbor_table             neighbortable;
extern struct neighbor2_hash             neighbor2table[HASHSIZE];

extern struct duplicatehash              duplicatetable[HASHSIZE];

extern struct mpr_selector_table         mprstable;

extern struct rthash                     routingtable[HASHSIZE];
extern struct rthash                     mirror_table[HASHSIZE];

extern struct topology_destination_hash  topologytable[HASHSIZE];
extern struct topology_last_hash         topologylasttable[HASHSIZE];

#if defined(__FreeBSD__)
extern olsr_16_t    kernel_raw_sock;    /*used to communicate with the kernel*/
#define SEQ 9999
#endif

extern FILE *f_r_id;

extern struct sockaddr_in addr;	/* address of daemon's socket */
extern olsr_ip_addr addr_ip;	/* IP address of "in_addr" */
extern olsr_ip_addr default_gateway;
extern int s;			/* source and sink of all data */
extern int supplier;		/* process should supply updates */
extern char	packet[MAXPACKETSIZE+1];
extern int      outputsize;
extern struct	olsr *msg;
extern short      hello_seqnum;  /* counter use to identifie HELLO PACKET */
extern short      tc_seqnum;     /* counter use to identifie TC PACKET */
extern struct	servent *sp;
extern struct timeval now;		/* current idea of time */
extern int changes;
extern int debug;

UINT64 timer_now;

extern FDesc logfile;
extern char logdata[PICA_ERR_BUF_SIZE];

u_long inet_netof_subnet(struct in_addr);
int inet_rtflags(struct sockaddr *);
int inet_sendroute(struct rt_entry *, struct sockaddr *);

void olsr_input(struct sockaddr *, struct olsr *, int);

void toall(void (*)(struct sockaddr *, struct hello_message *,
                    struct tc_message *, int,  struct _interface *), 
	   struct hello_message *, struct tc_message *, struct _interface *);

void sndmsg(struct sockaddr *, struct hello_message *, struct tc_message *,
            int, struct _interface *);

void supply(struct sockaddr *, struct hello_message *,
	    struct rt_message *, int);

void hello_build(struct sockaddr *, struct hello_message *, 
                 struct tc_message *, int, struct _interface *);

void tc_build(struct sockaddr *, struct hello_message *, 
              struct tc_message *, int, struct _interface *);

void rt_build(struct sockaddr *, struct rt_message *, int, 
	      struct _interface *);

//PICA
void gettime2(struct timeval * t_n, UINT64 * t_p);
#ifndef PICA_LINUX
void timeradd(struct timeval * a,struct timeval * b, struct timeval * result);
#endif

//void timer(int);
void timer(void * param);

void olsr_delete_all_kernel_routes(int signal);

void ifinit(void);

void ifinit_PICA(void);

void LOG(char * data);
