/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 */

/*
 * Copyright (c) 1983, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
char copyright[] =
  "@(#) Copyright (c) 2000, 2001\n"
  "  INRIA-HIPERCOM.  All rights reserved.\n";

/*
 * From: @(#)main.c	5.23 (Berkeley) 7/1/91
 * From: @(#)main.c	8.1 (Berkeley) 6/5/93
 * From: @(#)main.c	1.7 (dholland Exp)  1997/05/19
 */

char main_rcsid[] = 
  "$Id: main.c,v 1.2 2000/12/06 10:36:11 prima Exp $";

/*
 * Routing Table Management Daemon
 */

#include "defs.h"

#ifdef PICA_LINUX
#include <sys/ioctl.h>
#include <sys/file.h>
#include <syslog.h>
#include <sys/utsname.h>
#endif

//#include <net/if.h>

#include <errno.h>
#include <signal.h>

#ifdef PICA_LINUX
#define LOG_PATH "/var/log/olsrd.log"
#else
#define LOG_PATH "olsrd_log.txt"
#endif

struct sockaddr_in addr;        /* Address used as Originator Address */
olsr_ip_addr addr_ip;           /* sin_addr.s_addr member of the 
				   variable addr */
struct sockaddr_in addrsock;	/* address of daemon's socket */
int s;				/* source and sink of all data */
char	packet[MAXPACKETSIZE+1];
int     outputsize = 0;         /* current size of the 
				   output buffer (packet) */
struct	servent *sp;
//sigset_t sigset, osigset, psigset;

struct interf_name *interf_names = NULL; /* list of interface type on which olsr 
					    packets will be send */

int	supplier = 1;		/* process should supply updates */
int     option_i = 0;
int     filter = 0;
int	gateway = 0;		/* 1 if we are a gateway to parts beyond */
int	debug = 0;
int	bufspace = 127*1024;	/* max. input buffer size to request */
struct	olsr *msg = (struct olsr *)packet;

short     hello_seqnum = 1;     /* Hello packet counter which is use 
				   as unique identifier to HELLO PACKET */
short     tc_seqnum = 1;        /* TC packet counter which is use as unique
				   identifier to TC PACKET */

UINT64 next_event;
FDesc logfile;
char logdata[PICA_ERR_BUF_SIZE];


PICAsocket getsocket(int, int, struct sockaddr *);
void process(int);
void thrfunc(void * data);


int main(int argc, char *argv[])
{	

#ifndef PICA_LINUX
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	LPTSTR cmd_line;
	char * daemon_cmd;
#endif
 
	int tflags = 0;
    struct hello_message hellopack;
	struct _interface *ifp;
	//PICA
	PICAdescList * dl = NULL;
	PICAselResult res;	
	int admin, dif;	


	if (argc == 1) {
		fprintf(stderr,
				"usage: olsrd [ -s ] [ -q ] [ -d ] [ -t ] [ -i 'interface file'] [ -g ] [ 'trace file' ]\n");
		exit(1);
	}

#ifndef PICA_LINUX
	ZeroMemory(&si,sizeof(STARTUPINFO));

	cmd_line = GetCommandLine();
	if ((strstr(cmd_line, " -d ") == NULL) && (strstr(cmd_line, " -t ") == NULL)
		&& (strstr(cmd_line, " -z ") == NULL)) {
		daemon_cmd = (char *) malloc(strlen(cmd_line)+4);
		strcpy(daemon_cmd, argv[0]);
		strcat(daemon_cmd," -z");
		strcat(daemon_cmd, strstr(cmd_line," -"));
		
		CreateProcess(NULL,daemon_cmd ,NULL,NULL,FALSE,DETACHED_PROCESS,NULL,NULL,&si,&pi);
		
		free(daemon_cmd);
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
		
		exit(0);
	}
#endif	


	if (!PICAstartup(0)) exit(-1);

	if (!PICAisAdministrator(&admin)) {
	    fprintf(stderr,"Unable to check user.\n");
	    exit(-1);
	}
	if (!admin) {
	    fprintf(stderr,"You must have administrator previledges!\n");
	    exit(-1);
	}

	if (!PICAsetForwarding(FWD_ON)) {
	    fprintf(stderr,"Unable to turn on IP forwarding.\n");
	    exit(-1);
	}

	if (!PICAopenFile(&logfile, LOG_PATH,WRITEF, APPEND)) {
	    fprintf(stderr,"Unable to open log at: %s\n", LOG_PATH);
	    exit(-1);
	}

	sprintf(logdata, "Starting log! \n");
	LOG(logdata);


        sp = (struct servent *) malloc( sizeof(*sp));
	if (sp == 0) {
		printf("olsrd: out of memory\n");
		exit(1);
	}
        sp->s_name = "olsr";
        sp->s_aliases = NULL;
	sp->s_port = htons(OLSRPORT);
        sp->s_proto = "udp";
	memset(&addrsock, 0, sizeof (addrsock));
        addrsock.sin_family = AF_INET;
	addrsock.sin_port = sp->s_port;
	(addrsock.sin_addr).s_addr = INADDR_ANY;

	s = getsocket(AF_INET, SOCK_DGRAM, (struct sockaddr *)&addrsock);

	if (s < 0)
		exit(1);

/*
 * Process olsrd options.
 */

	argv++, argc--;
	while (argc > 0 && **argv == '-') {


		if (strcmp(*argv, "-z") == 0) {
			//in daemon mode
			argv++, argc--;
			continue;
		}
         /*
          *               For futur use.
          * Allow olsrd to supply neighbor and topology informations
          *           (default option).
          */
		if (strcmp(*argv, "-s") == 0) {
			supplier = 1;
			argv++, argc--;
			continue;
		}

         /*
          *               For futur use.
          * This option is opposite of -s
          */
		if (strcmp(*argv, "-q") == 0) {
			supplier = 0;
			argv++, argc--;
			continue;
		}

         /*
          * With this option all packets sent or received are printed on the 
          * standard output or in a specified file (the file name is the last 
          * argument of olsrd). In this case olsrd will not divorce itsef from
          * the controlling terminal. So interrupts from the keyboard will
          * kill the process.
          */

		if (strcmp(*argv, "-t") == 0) {
			tflags++;
//			setlogmask(LOG_UPTO(LOG_DEBUG));
			argv++, argc--;
			continue;
		}

        /*
         * Enable additional debugging information to be logged.
         */
		if (strcmp(*argv, "-d") == 0) {
			debug++;
//			setlogmask(LOG_UPTO(LOG_DEBUG));
			argv++, argc--;
			continue;
		}

        /*
         *               For futur use.
         * This option is used on internetwork routers to offer a route to 
         * the default destination.
         */

		if (strcmp(*argv, "-g") == 0) {
			gateway = 1;
			argv++, argc--;
			continue;
		}

        /*
       	 * Enable neighbor filter. Only packets received from neighbors 
	 * which have their address in a specified file are processed.
	 */
		if (strcmp(*argv, "-f") == 0) {
			argv++, argc--;
			filter++;
			continue;
		}
	/*
	 * To specify the name of an interface to be used by olsrd.
	 * Is required if more than one interface have configuured.
	 */
		if (strcmp(*argv, "-i") == 0) {
		    if (option_i == 0) { //only accepts first interface
			option_i = 1;
			argv++, argc--;
			ifchoice(*argv);
			argv++, argc--;
			continue;
		    }
		}

		fprintf(stderr,
			"usage: olsrd [ -s ] [ -q ] [ -d ] [ -t ] [ -i 'interface file'] [ -g ] [ 'trace file' ]\n");
		exit(1);
	}

	if (option_i == 0) { //forces user to define an interface
	    fprintf(stderr,
			"You must define an interface!\nusage: olsrd [ -s ] [ -q ] [ -d ] [ -t ] [ -i 'interface'] [ -g ] [ 'trace file' ]\n");
		exit(1);
	}

	ifinit_PICA();

        /*
         * To divorce the processe from the controlling terminal.
         * So interrupts from the keyboard won't kill the process.
         */

#ifdef PICA_LINUX
	if (debug == 0 && tflags == 0)
	{
	    if (daemon(1,0)) exit(-1); 
	}	
#endif

	/*
	 * Any extra argument is considered
	 * a tracing log file.
	 */

	if (argc > 0)
		traceon(*argv);
	if (tflags && ftrace == NULL)
		ftrace = stderr;
	while (tflags-- > 0)
		bumploglevel();


	gettime2(&now,&timer_now);


        /* Choice of the Originator address. In this version ifnet contain
	   one interface */

	memset(&addr, 0, sizeof (addr));
	for (ifp = ifnet; ifp; ifp = ifp->int_next) {
/*		if (ifp->int_flags & IFF_PASSIVE )
		continue;*/
		addr = *(struct sockaddr_in *)&ifp->int_addr;
                break;
	}
	
	if (ifp)
	 addr_ip = addr.sin_addr.s_addr;
        else 
	  exit(1);
       
	/* Initialisation of differents tables to be used.*/

        olsr_init_tables();
          
        if (filter)    
         load_topology_filter();
     
       /* 
        * Build and send empty HELLO.
        */

        hellopack.neighbors = (struct hello_neighbor *)NULL;
        olsr_build_hello_packet(&hellopack);
   
        toall(hello_build, &hellopack, (struct tc_message *)NULL,
             (struct _interface *)NULL);
        toall(sndmsg, (struct hello_message *)NULL, 
             (struct tc_message *)NULL, (struct _interface *)NULL);


	signal(SIGINT, olsr_delete_all_kernel_routes);  

	next_event = timer_now + (TIMER_RATE * 1000); //ms value

	if (!PICAaddDesc(&dl, PICA_SOCKET_TYPE,PICA_W_READ, &s)) {
	    fprintf(stderr, "Unable to add descriptor for select\n");
	    exit(-1);
	}

	for (;;){

		dif = (int) (next_event-PICAgetCurrTime());						
		if (dif < 0) dif = 0;

	    if (!PICAselect(dif, dl, &res)) { 	    

		    sprintf(logdata, "select: %s\n", strerror(errno));
		    LOG(logdata);

	    } else {	    	
		
			if (res.type == PICA_TIMEOUT_TYPE) {				
				timer(NULL);		
				next_event += (TIMER_RATE * 1000);
			} else {	
				gettime2(&now,&timer_now);						
				
				if (*((PICAsocket *) (res.desc)) == s) {
					
				process(s);
					
				} else fprintf(stderr,"Unknown error: sockets do not match\n");

			}
			
		} //else from PICAselect
	 

	} /* for(;;) */

} /* main */


void process(int fd)
{
	struct sockaddr from;
	size_t fromlen;
	int cc;
	union {
		char	buf[MAXPACKETSIZE+1];
		struct	olsr olsr;
	} inbuf;

	for (;;) {
		fromlen = sizeof (from);
		cc = recvfrom(fd, &inbuf, sizeof (inbuf), 0, &from, 
			      &fromlen);
		if (cc <= 0) {
#ifdef PICA_LINUX
			if (cc < 0 && errno != EWOULDBLOCK)
				perror("recvfrom");
#else
			if (cc < 0 && WSAGetLastError() != WSAEWOULDBLOCK)
				perror("recvfrom");
#endif
			break;
		}
	
		if (fromlen != sizeof (struct sockaddr_in))
			break;
	
		olsr_input(&from, &inbuf.olsr, cc);
	
	}
}


PICAsocket getsocket(int domain, int type, struct sockaddr *sa)
{
	struct sockaddr_in *sin=(struct sockaddr_in *)sa;
	int on = 1, non_block = 1;
	PICAsocket sock;

	if (!PICAcreateSocket(&sock,domain, type, 0)) {
	    perror("socket");	    
	    sprintf(logdata, "socket: %s\n", strerror(errno));
	    LOG(logdata);
	    return (-1);
	}

#ifdef SO_BROADCAST
	if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, &on, sizeof (on)) < 0)
	  {
		sprintf(logdata, "setsockopt SO_BROADCAST: %s\n", strerror(errno));
	    LOG(logdata);
		PICAcloseSocket(sock);
		return (-1);
	  }
#endif

#ifdef SO_RCVBUF
	for (on = bufspace; ; on -= 1024) {
		if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF,
		    (char *) &on, sizeof (on)) == 0)
			break;
		if (on <= 8*1024) {			
			sprintf(logdata, "setsockopt SO_RCVBUF: %s\n", strerror(errno));
			LOG(logdata);
			break;
		}
	}
	if (traceactions)
		fprintf(ftrace, "recv buf %d\n", on);
#endif

	if (bind(sock, (struct sockaddr *)sin, sizeof (*sin)) < 0) {
		perror("bind");		
		sprintf(logdata, "bind: %s\n", strerror(errno));
		LOG(logdata);
		PICAcloseSocket(sock);
		return (-1);
	}

#ifdef PICA_LINUX
	if (fcntl(sock, F_SETFL, O_NONBLOCK) == -1) {
	    sprintf(logdata, "fcntl O_NONBLOCK: %s\n", strerror(errno));
	    LOG(logdata);
	}
#else 
	if (ioctlsocket(sock,FIONBIO,&non_block) != 0) {
		sprintf(logdata, "setsockopt SO_RCVBUF: %s\n", strerror(errno));
	    LOG(logdata);
	}
#endif
	return (sock);
}

void LOG(char * data) {
    
    char logdata2[256], * date_str;

    PICAgetTimeStr(&date_str);
    sprintf(logdata2, "%s> %s\n",date_str, data);
    PICAwriteToFile(logfile, logdata2, strlen(logdata2));  
    //free(date_str);

}
/*
void thrfunc(void * data) {

    UINT64 timer_aux;
	int dif;
	char msg[100];
	int code;

	if (!PICAsemaphoreAction(SEMAPHORE_RELEASE, &sync_sem,1)) {
	    fprintf(stderr,"Error releasing semaphore\n");
	    exit(-1);
	}

    while (1) {

//printf("Trying to acquire semaphore in thread\n");

#ifdef PICA_LINUX
	if (!PICAsemaphoreAction(SEMAPHORE_ACQUIRE, &timer_sem,1)) {
	    fprintf(stderr,"Error acquiring semaphore\n");
	    exit(-1);
	}

//	printf("Setting timer\n");

	timer_aux = next_event;

	if (!PICAtimer(T_SET, &timer_aux, &timer, NULL)) {
	    fprintf(stderr,"Error resetting timer\n");
	}		
#else
		dif = next_event-PICAgetCurrTime();
		
		if (dif > 0) 
			Sleep(dif);
		timer(NULL);

#endif
	next_event += (TIMER_RATE * 1000);
    }
}
*/