/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 * 
 *	$Id: mpr_selector_table.h,v 1.2 2000/12/06 10:36:11 prima Exp $
 */


/*
 * Routing table management daemon.
 */


/*
 * MultiPoint Relay Selector table structure.
 */

struct mpr_selector_info {

        olsr_u32_t      mprselector_hash;
        olsr_ip_addr      mpr_selector_addr;
	olsr_u16_t       mpr_selector_seq;
	struct timeval	mpr_selector_timer;		        
};


struct mpr_selector_entry {
	struct	mpr_selector_entry *mpr_selector_forw;
	struct	mpr_selector_entry *mpr_selector_back;
        struct  mpr_selector_info mpr_selector_infos;
};


#define	mprselector_hash      	mpr_selector_infos.mprselector_hash

#define	mpr_selector_addr      	mpr_selector_infos.mpr_selector_addr    /* MultiPoint Relay selector address */
#define	mpr_selector_seq    	mpr_selector_infos.mpr_selector_seq     /* MPRS sequence number with
									   which mprs_addr has selected
									   this node as its MPR */
#define	mpr_selector_timer     	mpr_selector_infos.mpr_selector_timer   /* for invalidation */

struct mpr_selector_hash {
  struct	mpr_selector_entry *mpr_selector_forw;
  struct	mpr_selector_entry *mpr_selector_back;
};

struct mpr_selector_table {
  olsr_u16_t      mssn;
  struct	mpr_selector_hash *mpr_selector_hash;
};


int
olsr_delete_mpr_selector_table(struct mpr_selector_entry *mprs);

int
olsr_insert_mpr_selector_table(struct mpr_selector_entry *mprs);

struct mpr_selector_entry
*olsr_lookup_mpr_selector_table(olsr_ip_addr *dst);

int
olsr_update_mpr_selector_table(struct hello_message *message);

int
olsr_release_mpr_seletector_table();

int
olsr_time_out_mpr_selector_table();

int
olsr_print_mpr_selector_table();
