/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 */

/*
 * Copyright (c) 1983, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * From: @(#)startup.c	5.19 (Berkeley) 2/28/91
 * From: @(#)startup.c	8.1 (Berkeley) 6/5/93
 */

char startup_rcsid[] = 
  "$Id: startup.c,v 1.2 2000/12/06 10:36:12 prima Exp $";


/*
 * Routing Table Management Daemon
 */

#include "defs.h"

#ifdef PICA_LINUX
#include <sys/ioctl.h>
#endif

#include <errno.h>

struct	_interface *ifnet;
struct	_interface **ifnext = &ifnet;
extern int option_i;
extern struct interf_name *interf_names;/* list of interface on which olsr
				          packets will be send */

/*
 * Find the network broadcast interfaces which have configured.
 * If several interfaces are configurated, only interfaces
 * matching with the names specified in option are maintained.
 * In this version only one interface is required. 
 */


void ifchoice(char *name)
{

  struct interf_name *interf_n;

       interf_n = (struct interf_name *)malloc(sizeof(interf_n));
       if (interf_n == 0) {
	     fprintf(stderr, "olsrd: ifinit: out of memory\n");
	     //syslog(LOG_ERR, "olsrd: ifinit: out of memory\n");
	     LOG("olsrd: ifinit: out of memory\n");
	     return;
       }
       interf_n->name = (char *)malloc(strlen(name));
       if (interf_n->name == 0) {
	     fprintf(stderr, "olsrd: ifinit: out of memory\n");
	     //syslog(LOG_ERR, "olsrd: ifinit: out of memory\n");
	     LOG("olsrd: ifinit: out of memory\n");
	     return;
       }
       strcpy(interf_n->name, name);
       interf_n->next = interf_names;
       interf_names = interf_n;

}

void ifinit_PICA(void) {

    DEVLIST devs;
    DevAttrs attrs;
    int i;
    struct _interface *ifp;
    struct sockaddr_in * helper;

	//debug
//	struct in_addr test;
    
    if ((ifp = (struct _interface *)malloc(sizeof (struct _interface))) == 0) {
	 fprintf(stderr,"olsrd: out of memory\n");
	 exit(-1);
    }

#ifdef PICA_LINUX
    bzero(ifp, sizeof(struct _interface));
#else
	ZeroMemory((void *) ifp, sizeof(struct _interface));
#endif
    
    if (PICAgetAvailableDevices(&devs) == 0) {
	fprintf(stderr,"Error getting available devices\n");
	exit(-1);
    } else if (devs.num_devices == 0) {
	fprintf(stderr,"Error: no device available\n");
	exit(-1);
    }

	
    for (i=0;i<devs.num_devices;i++) {
	if (strcmp(interf_names->name, devs.dev_names[i]) == 0) {
	    if (!PICAgetDeviceAttrs(devs.dev_names[i], &attrs)) {
		fprintf(stderr,"Error: Device attributes unavailable\n");
		exit(-1);
	    }
	    
//	    nbinterf++; //maybe unnecessary

	    helper = (struct sockaddr_in *) & ifp->int_addr;
	    helper->sin_addr.s_addr = ntohl(attrs.ip_addr);  //IP address - host order
	    helper->sin_family = AF_INET;

	    if (IN_CLASSA(helper->sin_addr.s_addr)) //netmask
			ifp->int_netmask = htonl(IN_CLASSA_NET);
		else if (IN_CLASSB(helper->sin_addr.s_addr))
			ifp->int_netmask = htonl(IN_CLASSB_NET);
	    else 
		    ifp->int_netmask = ntohl(IN_CLASSC_NET);		
	    
	    helper->sin_addr.s_addr = attrs.ip_addr; //IP address NBO
	    
	    ifp->int_net =  attrs.ip_addr & ifp->int_netmask; //network
	    
	    //  Pretend we don't know what the subnet, subnet mask 
	    //  and broadcast adress is for now. Suppose there is no
	    //  subnetting.

	    ifp->int_subnetmask = attrs.mask;
	    ifp->int_subnet = attrs.ip_addr & ifp->int_subnetmask;

	    helper = (struct sockaddr_in *) & ifp->int_broadaddr;
	    helper->sin_addr.s_addr = attrs.ip_addr | (ifp->int_subnetmask ^ 0xFFFFFFFF);	  
	    helper->sin_family = AF_INET;  	   	    

		//debugging	    
/*		helper = (struct sockaddr_in *) & ifp->int_addr;
	    test = helper->sin_addr;
	    printf("IP addr is: %s\n", inet_ntoa(test));
	    helper = (struct sockaddr_in *) & ifp->int_broadaddr;
	    test = helper->sin_addr;
	    printf("Broadcast addr is: %s\n", inet_ntoa(test));
	    test.s_addr = ifp->int_subnetmask;
	    printf("Subnetmask is addr is: %s\n", inet_ntoa(test));
	    test.s_addr = ifp->int_netmask;
	    printf("Netmask is addr is: %s\n", inet_ntoa(test));
*/	    
	    
	    
	    //Save interface name
	    ifp->int_name = (char *)malloc(strlen(devs.dev_names[i]) + 1);
	    strcpy(ifp->int_name, devs.dev_names[i]);
//	    printf("Interface is: %s\n", ifp->int_name);

	    //Simulate flags
	    ifp->int_flags = 0x400003;

//printf("Ifinit: flags are %x\n", ifp->int_flags);

	    //Keep ????
	    *ifnext = ifp;
	    ifnext = &ifp->int_next;



	    traceinit(ifp);
	    return;
	}
    }

    
    fprintf(stderr,"Chosen device is not available. Please use one of the following:\n");
    for (i=0;i<devs.num_devices;i++) 
	printf("%s\n", devs.dev_names[i]);
    exit(-1);
}

