/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 *
 *	$Id: top_statique.h,v 1.2 2000/12/06 10:36:12 prima Exp $
 */


struct address_neighbor{
  struct in_addr address;
  struct address_neighbor *next;
};

#define	ADD_NEIGHBOR	1		/* uni-directional link */
#define	DEL_NEIGHBOR 	2		/* bi-directional link */

extern struct address_neighbor *neighbors_network_address;
extern struct timeval hold_time_neighbor_fixed;
int
load_topology_filter();

int
//is_neighbor(struct sockaddr_in *recv_address,struct sockaddr_in  *send_address);
is_neighbor(struct sockaddr_in *recv_node,struct sockaddr_in  *send_node);

int
add_fictif_neighbors(char *address_presentation);

int
print_topology();

int
update_static_neighborhood(struct hello_message *message);

struct address_neighbor 
*already_exist_in_neighborhood(olsr_ip_addr address);

int
del_from_static_neighborhood(olsr_ip_addr address);

int
add_to_static_neighborhood(olsr_ip_addr address);
