/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 */

/*
 * Routing table management daemon.
 */

char topology_table_rcsid[] = 
  "$Id: topology_table.c,v 1.2 2000/12/06 10:36:12 prima Exp $";


#include "defs.h"


struct topology_destination_hash  topologytable[HASHSIZE];
struct topology_last_hash         topologylasttable[HASHSIZE];

/*-----------------------------------------------------------------------*/
int
olsr_delete_list_of_last(struct topology_last_entry *last_entry,olsr_ip_addr *dst)
{
  
  struct destination_list            *dest_list;
  struct destination_list            *dest_list_tmp;
  
  dest_list=last_entry->topology_list_of_destinations;
  last_entry->topology_list_of_destinations=NULL;

  while(dest_list!=NULL)
    { 
      if(0==memcmp(&dest_list->destination_node->topology_destination_dst,dst,sizeof(olsr_ip_addr)))    
	{
	  dest_list_tmp=dest_list;
	  dest_list=dest_list->next;
	  free(dest_list_tmp);
	}
      else
	{
	  dest_list_tmp=dest_list;
	  dest_list=dest_list->next;
	  dest_list_tmp->next=last_entry->topology_list_of_destinations;
	  last_entry->topology_list_of_destinations=dest_list_tmp;
	}
    }

}
/*------------------------------------------------------------------------*/
int
olsr_delete_dest_topolgy_table(struct topology_destination_entry *dest_entry)
{
  struct last_list *list_of_last;
  struct topology_last_entry *last_entry;

  list_of_last=dest_entry->topology_destination_list_of_last;

  while(list_of_last!=NULL)
    {
      last_entry=list_of_last->last_neighbor;
      olsr_delete_list_of_last(last_entry,&dest_entry->topology_destination_dst);              
      dest_entry->topology_destination_list_of_last=list_of_last->next;
      free(list_of_last);  
      list_of_last=dest_entry->topology_destination_list_of_last;
       
    }
olsr_remque((struct olsr_qelem *)dest_entry);
free((void *)dest_entry);
}
/*------------------------------------------------------------------------*/
int
olsr_delete_list_of_dest(struct topology_destination_entry *dest_entry,olsr_ip_addr *dst)
{
  struct last_list  *list_of_last;
  struct last_list  *list_of_last_tmp;

 list_of_last=dest_entry->topology_destination_list_of_last;
 dest_entry->topology_destination_list_of_last=NULL;
 while(list_of_last!=NULL)
   {
     if(0==memcmp(&list_of_last->last_neighbor->topology_last,dst,sizeof(olsr_ip_addr)))
       {
	 list_of_last_tmp=list_of_last;
	 list_of_last=list_of_last->next;
	 free(list_of_last_tmp);
       }
     else
       {
	 list_of_last_tmp=list_of_last;
	 list_of_last=list_of_last->next;
	 list_of_last_tmp->next=dest_entry->topology_destination_list_of_last;
	 dest_entry->topology_destination_list_of_last=list_of_last_tmp;
       }
   }

  if(dest_entry->topology_destination_list_of_last==NULL)
    {
      olsr_remque((struct olsr_qelem *)dest_entry);
      free((void *)dest_entry);
    }
}
/*------------------------------------------------------------------------*/
int
olsr_delete_last_topolgy_table(struct topology_last_entry *last_entry)
{
  struct destination_list    *list_of_dest;
  struct topology_destination_entry *dest_entry;

  list_of_dest=last_entry->topology_list_of_destinations;

  while(list_of_dest!=NULL)
    {
      dest_entry=list_of_dest->destination_node;

      olsr_delete_list_of_dest(dest_entry,&last_entry->topology_last);
      last_entry->topology_list_of_destinations=list_of_dest->next;      
      free(list_of_dest);  
      list_of_dest=last_entry->topology_list_of_destinations;
       
    }

  olsr_remque((struct olsr_qelem *)last_entry);
  free((void *)last_entry);
}
/*------------------------------------------------------------------------*/
int
olsr_insert_last_topology_table(struct topology_last_entry *last_entry,struct tc_message *message)
{
  olsr_u32_t                  hash;
  struct topology_last_hash   *top_last_hash;
  
  olsr_hashing(&message->originator,&hash);
  top_last_hash=&topologylasttable[hash & HASHMASK];

  memcpy(&last_entry->topology_last,&message->originator,sizeof(olsr_ip_addr));
  last_entry->topology_list_of_destinations=NULL;
  last_entry->topologylast_hash=hash;
  last_entry->topology_seq=message->mssn;

  timeradd(&now,&hold_time_topology,&last_entry->topology_timer);

  olsr_insque((struct olsr_qelem *)last_entry, (struct olsr_qelem *)top_last_hash);
}
/*------------------------------------------------------------------------*/
int
olsr_insert_dest_topology_table(struct topology_destination_entry *dest_entry,struct tc_mpr_addr *mpr)
{
  olsr_u32_t                         hash;
  struct topology_destination_hash   *top_dest_hash;

  olsr_hashing(&mpr->address,&hash);

  top_dest_hash=&topologytable[hash & HASHMASK];
                 
  memcpy(&dest_entry->topology_destination_dst,&mpr->address,sizeof(olsr_ip_addr));

  dest_entry->topology_destination_list_of_last=NULL;
  dest_entry->topologydestination_hash=hash;

  olsr_insque((struct olsr_qelem *)dest_entry, (struct olsr_qelem *)top_dest_hash);
}
/*------------------------------------------------------------------------*/
struct topology_last_entry  
*olsr_lookup_last_topology_table(olsr_ip_addr *last)
{
  struct topology_last_entry  *top_last;
  struct topology_last_hash   *top_last_hash;
  olsr_u32_t                  hash;

  olsr_hashing(last,&hash);

  top_last_hash=&topologylasttable[hash & HASHMASK];

  for(top_last=top_last_hash->topology_last_forw;top_last!=(struct topology_last_entry *)top_last_hash;top_last=top_last->topology_last_forw)
    {
      if(top_last->topologylast_hash!=hash)
	continue;

      if (0==memcmp(&top_last->topology_last,last,sizeof(olsr_ip_addr)))
	return(top_last);
      
    }
  return (NULL);

}
/*------------------------------------------------------------------------*/
struct topology_destination_entry
*olsr_lookup_dest_topology_table(olsr_ip_addr *dest)
{

  struct topology_destination_entry    *top_dest;
  struct topology_destination_hash     *top_dest_hash;
  olsr_u32_t                           hash;

  /*-------------------*/
  if (debug)
    {
      printf("olsr_lookup_dest_topology_table\n");
    }
  /*-------------------*/
  
  olsr_hashing(dest,&hash);

  top_dest_hash=&topologytable[hash & HASHMASK];

  for(top_dest=top_dest_hash->topology_destination_forw;top_dest!=(struct topology_destination_entry *)top_dest_hash;top_dest=top_dest->topology_destination_forw)
    {
      if(top_dest->topologydestination_hash!=hash)
	continue;
 
      if (0==memcmp(&top_dest->topology_destination_dst,dest,sizeof(olsr_ip_addr)))
	return(top_dest);
      
    }
  return (NULL);
}
/*------------------------------------------------------------------------*/
struct  destination_list 
*olsr_in_list_dest_topo(struct topology_last_entry *last_entry,olsr_ip_addr *address)
{
 struct  destination_list *list_of_dest;

 list_of_dest=last_entry->topology_list_of_destinations;

 /*----------------*/
 if (debug)
   {
     printf("olsr_in_list_dest_topo\n");
   }
 /*----------------*/
 
 while(list_of_dest!=NULL)
   {
     if(0==(memcmp(&list_of_dest->destination_node->topology_destination_dst,address,sizeof(olsr_ip_addr))))
       return(list_of_dest);
     list_of_dest=list_of_dest->next;
   }
 return(NULL);
}
/*------------------------------------------------------------------------*/
int
olsr_update_last_table(struct topology_last_entry *last_entry,struct tc_message *message)
{
  /*
    This function updates the time out for the existant pointed by t_last and 
    creates new entries for the new destinations    
  */
  
  struct tc_mpr_addr                *mpr;
  struct destination_list           *topo_dest;
  struct topology_destination_entry *destination_entry;
  struct last_list                  *topo_last;

  mpr=message->multipoint_relay_selector_address;

  timeradd(&now,&hold_time_topology,&last_entry->topology_timer);
  /*-----------------*/
   if(debug)
     {
	 //    printf("UPDATING THIS TOP_LAST!!!!!!!!! le timeout est %d et le now is %d \n",ctime((time_t *)&last_entry->topology_timer.tv_sec),ctime((time_t *)&now.tv_sec));
	 printf("UPDATING THIS TOP_LAST!!!!!!!!! timeout is %d and now is %d \n",(int)(last_entry->topology_timer.tv_sec),(int) (now.tv_sec));
       printf("The list of MPRs is\n:");
       while(mpr!=NULL)
	 {
	   printf("This mpr is %s\n",convert_address_to_string(&mpr->address));
	   mpr=mpr->next;
	 }
       mpr=message->multipoint_relay_selector_address;
     }
   /*-----------------*/

  while(mpr!=NULL)
    {
      if(0!=memcmp(&mpr->address,&addr_ip,sizeof(olsr_ip_addr))) 
	
	if(NULL==(topo_dest=olsr_in_list_dest_topo(last_entry,&mpr->address)))
	  {
	    /*----------------*/
	    if (debug)
	      {
		printf("Ce DEST n'est pas dans la liste liee a ce LAST\n");
	      }
	    /*----------------*/

	    changes_topology=UP;
	    if(NULL==(destination_entry=olsr_lookup_dest_topology_table(&mpr->address)))
	      {	
		destination_entry=(struct topology_destination_entry * )malloc(sizeof(struct topology_destination_entry));
		olsr_insert_dest_topology_table(destination_entry,mpr);
		
	      }
	    /* creating the structure for the linkage*/

	    topo_dest=(struct  destination_list *)malloc(sizeof(struct  destination_list));
	    topo_dest->next=last_entry->topology_list_of_destinations;
	    last_entry->topology_list_of_destinations=topo_dest;

	    topo_last=(struct last_list *)malloc(sizeof(struct last_list));
	    topo_last->next=destination_entry->topology_destination_list_of_last;
	    destination_entry->topology_destination_list_of_last=topo_last;
	    /*linking the last and the dest*/
	    topo_last->last_neighbor=last_entry;
	    topo_dest->destination_node=destination_entry;
	  }	
      
      /*-----------------*/
      if (debug)
	{
	  printf("This mpr is %s\n",convert_address_to_string(&mpr->address));
	  if(mpr->next==NULL)
	    printf("the next is NULL\n");
	  else
	    printf("the next is not NULL\n");
	}
      /*-----------------*/

      mpr=mpr->next;
    }

  
}
/*------------------------------------------------------------------------*/
int
olsr_release_topology_table()
{
  olsr_u8_t                            index;

  struct topology_destination_entry    *top_dest;
  struct topology_destination_entry    *top_dest_tmp;
  struct topology_destination_hash     *top_dest_hash;

  struct topology_last_entry           *top_last;
  struct topology_last_entry           *top_last_tmp;
  struct topology_last_hash            *top_last_hash;

  for(index=0;index<HASHSIZE;index++)
  {
    top_dest_hash=&topologytable[index];
    top_dest=top_dest_hash->topology_destination_forw;
    while(top_dest!=(struct topology_destination_entry *)top_dest_hash)
      {
	top_dest_tmp=top_dest;
	top_dest=top_dest->topology_destination_forw;	
	olsr_delete_dest_topolgy_table(top_dest_tmp);
      }
  }

  for(index=0;index<HASHSIZE;index++)
    {
      top_last_hash=&topologylasttable[index];
      top_last=top_last_hash->topology_last_forw;
      while(top_last!=(struct topology_last_entry *)top_last_hash)
	  {
	    top_last_tmp=top_last;
	    top_last=top_last->topology_last_forw;
	    olsr_delete_last_topolgy_table(top_last_tmp);
	  }
    }
}
/*------------------------------------------------------------------------*/
int
olsr_time_out_topology_table()
{
  /* 
     We only check the last table because we didn't include a time out in the dest entries
  */
  olsr_u8_t                            index;
  struct topology_last_entry           *top_last;
  struct topology_last_entry           *top_last_tmp;
  struct topology_last_hash            *top_last_hash;
  
  for(index=0;index<HASHSIZE;index++)
    {
      top_last_hash=&topologylasttable[index];
      top_last=top_last_hash->topology_last_forw;
      while(top_last!=(struct topology_last_entry *)top_last_hash)
	{
	  
	  if(olsr_timed_out(&top_last->topology_timer))
	    {
	      /*-----------------*/
	      if(debug)
		{
		  printf("TIMEOUT POUR CE TOP_LAST!!!!!!!!! le timeout est %d  %d et le now is %d %d \n",top_last->topology_timer.tv_sec,top_last->topology_timer.tv_usec,now.tv_sec,now.tv_usec);
		}
	      /*----------------*/

	      top_last_tmp=top_last;
	      top_last=top_last->topology_last_forw;
	      olsr_delete_last_topolgy_table(top_last_tmp);
	      
	      changes_topology=UP;
	    }
	  else
	    top_last=top_last->topology_last_forw;
	}
    }
}
/*------------------------------------------------------------------------*/
int
olsr_print_topology_table()
{
  olsr_u8_t                            index;
  struct topology_last_entry           *top_last;
  struct topology_last_hash            *top_last_hash;
  struct destination_list              *top_dest_list;

  printf("TOPOLOGY TABLE\n");
  for(index=0;index<HASHSIZE;index++)
    {
      top_last_hash=&topologylasttable[index];
      for(top_last=top_last_hash->topology_last_forw;top_last!=(struct topology_last_entry *)top_last_hash;top_last=top_last->topology_last_forw)
	{
	  printf("ADDRESS        \n");
	  printf("%s \n",convert_address_to_string(&top_last->topology_last));
	  printf("LAST HOP OF\n");
	  
	  top_dest_list=top_last->topology_list_of_destinations;
	  
	  while(top_dest_list!=NULL)
	    {
	      printf("%s \n",convert_address_to_string(&top_dest_list->destination_node->topology_destination_dst));
	      top_dest_list=top_dest_list->next;
	    }
	}
    }
}
/*------------------------------------------------------------------------*/
