/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 * 
 *	$Id: topology_table.h,v 1.2 2000/12/06 10:36:12 prima Exp $
 */

/*
 * Routing table management daemon.
 *
 */


/*
 *Topology table structure.
 */


struct last_list{
        struct last_list  *next;
        struct topology_last_entry *last_neighbor;       
};




struct topology_destination_infos{
        olsr_u32_t        topologydestination_hash;
        olsr_ip_addr      topology_dst;
        struct  last_list *list_of_last;
};

struct topology_destination_entry{
       	struct	topology_destination_entry *topology_destination_forw;
	struct	topology_destination_entry *topology_destination_back; 
        struct  topology_destination_infos  topology_destination_info;

};

#define topologydestination_hash         topology_destination_info.topologydestination_hash

#define topology_destination_dst          topology_destination_info.topology_dst

#define topology_destination_list_of_last topology_destination_info.list_of_last

struct destination_list{
        struct destination_list  *next;
        struct topology_destination_entry *destination_node;

};

struct topology_last_infos {
	olsr_u32_t              topologylast_hash;
        olsr_ip_addr            topology_last;
	olsr_u16_t              topology_seq;
	struct timeval	        topology_timer;		        
        struct destination_list *list_of_destinations;
};


struct topology_last_entry {
	struct	topology_last_entry *topology_last_forw;
	struct	topology_last_entry *topology_last_back;
        struct  topology_last_infos  topology_last_infos;
};


#define	topologylast_hash     topology_last_infos.topologylast_hash

#define	topology_last     topology_last_infos.topology_last      /* node selected by topo_dst 
							       as a MultiPoint Relay */
#define	topology_seq      topology_last_infos.topology_seq       /* sequence number with which 
							       topo_last announced this information */
#define	topology_timer    topology_last_infos.topology_timer      /* for invalidation */
#define topology_list_of_destinations topology_last_infos.list_of_destinations 

struct topology_last_hash {
	struct	topology_last_entry *topology_last_forw;
	struct	topology_last_entry *topology_last_back;
};



struct topology_destination_hash{
        struct	topology_destination_entry *topology_destination_forw;
	struct	topology_destination_entry *topology_destination_back;
};

int
olsr_delete_list_of_last(struct topology_last_entry *last_entry,olsr_ip_addr *dst);

int
olsr_delete_dest_topolgy_table(struct topology_destination_entry *dest_entry);

int
olsr_delete_list_of_dest(struct topology_destination_entry *dest_entry,olsr_ip_addr *dst);

int
olsr_delete_last_topolgy_table(struct topology_last_entry *last_entry);

int
olsr_insert_last_topology_table(struct topology_last_entry *last_entry,struct tc_message *message);

int
olsr_insert_dest_topology_table(struct topology_destination_entry *dest_entry,struct tc_mpr_addr *mpr);

struct topology_last_entry  
*olsr_lookup_last_topology_table(olsr_ip_addr *last);

struct topology_destination_entry
*olsr_lookup_dest_topology_table(olsr_ip_addr *dest);

struct  destination_list 
*olsr_in_list_dest_topo(struct topology_last_entry *last_entry,olsr_ip_addr *addr);

int
olsr_update_last_table(struct topology_last_entry *last_entry,struct tc_message *message);

int
olsr_release_topology_table();

int
olsr_time_out_topology_table();

int
olsr_print_topology_table();
