/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/


/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 *
 *	$Id: two_hop_neighbor_table.h,v 1.2 2000/12/06 10:36:12 prima Exp $
 */

/*
 * Routing table management daemon.
 */


/*
 *Two hops neighbor table structure.
 */

struct neighbor_list_entry {
	struct	neighbor_list_entry *neighbor_next;
	struct	neighbor_entry *neighbor;
};

struct neighbor_2_info {
	olsr_u32_t                  neighbor_2_hash;
        olsr_ip_addr                neighbor_2_addr;
	olsr_u8_t      	            neighbor_2_state;    /*used in mpr calculation*/
	olsr_16_t                   neighbor_2_pointer;
	struct	neighbor_list_entry *neighbor_2_nblist; 
};


struct neighbor_2_entry {
	struct	neighbor_2_entry *neighbor_2_forw;
	struct	neighbor_2_entry *neighbor_2_back;
        struct  neighbor_2_info  neighbor_2_infos;
};


#define	neighbor_2_hash	     neighbor_2_infos.neighbor_2_hash
#define	neighbor_2_addr      neighbor_2_infos.neighbor_2_addr                 /* two hops neighbor address */
#define	neighbor_2_pointer   neighbor_2_infos.neighbor_2_pointer              /* number of one hop neighbor
								                 pointing to this two hops neighbor */
#define	neighbor_2_state     neighbor_2_infos.neighbor_2_state                /* see bellow */

#define neighbor_2_nblist    neighbor_2_infos.neighbor_2_nblist               /* list of the one hop neighbor, neighbor to
										 this two hops neighbor */

#define	HASHSIZE	32		/* must be a power of 2 */
#define	HASHMASK	(HASHSIZE - 1)

struct neighbor2_hash {
	struct	neighbor_2_entry *neighbor2_forw;
	struct	neighbor_2_entry *neighbor2_back;
};

/*
 * "State" of two hops neighbor.
 */
#define	NB2S_COVERED 	0x1		/* node has been covered by a MPR */



int
olsr_delete_neighbor_pointer(struct neighbor_2_entry *two_hop_entry,olsr_ip_addr *address);

int
olsr_delete_two_hop_neighbor_table(struct neighbor_2_entry *two_hop_neighbor);

int
olsr_insert_two_hop_neighbor_table(struct neighbor_2_entry *two_hop_neighbor);

struct neighbor_2_entry 
*olsr_lookup_two_hop_neighbor_table(olsr_ip_addr *dest);

int
olsr_release_two_hop_neighbor_table();

int
olsr_print_two_hop_neighbor_table();
