/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/


/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 *
 *	$Id: types.h,v 1.2 2000/12/06 10:36:12 prima Exp $
 */

/*
 * Routing table management daemon.
 */

/*
  Types definitions
*/

#if defined(linux)
#	include <sys/types.h> /* uint_xxx */
        typedef u_int8_t        olsr_u8_t;
        typedef u_int16_t       olsr_u16_t;
        typedef u_int32_t       olsr_u32_t;
        typedef int8_t          olsr_8_t;
        typedef int16_t         olsr_16_t;
        typedef int32_t         olsr_32_t;
        typedef olsr_u32_t      olsr_ip_addr;
#elif defined(__FreeBSD__)
#	include <sys/types.h> /* uint_xxx */
	typedef	uint8_t		olsr_u8_t;
	typedef uint16_t       	olsr_u16_t;
	typedef uint32_t       	olsr_u32_t;
        typedef int8_t          olsr_8_t;
        typedef int16_t         olsr_16_t;
        typedef int32_t         olsr_32_t;
        typedef olsr_u32_t      olsr_ip_addr;
#else //Windows
	typedef	unsigned __int8		olsr_u8_t;
	typedef unsigned __int16       	olsr_u16_t;
	typedef unsigned __int32       	olsr_u32_t;
        typedef __int8          olsr_8_t;
        typedef __int16         olsr_16_t;
        typedef __int32         olsr_32_t;
        typedef olsr_u32_t      olsr_ip_addr;

//#else
//#	error "Unsupported system"
#endif    
